aboutsummaryrefslogtreecommitdiffstats
path: root/target/linux/mvebu/cortexa9
diff options
context:
space:
mode:
authorAdrian Schmutzler <freifunk@adrianschmutzler.de>2020-01-18 02:21:13 +0100
committerAdrian Schmutzler <freifunk@adrianschmutzler.de>2020-01-21 14:24:49 +0100
commit1fa04b5d9fb1cba56a8597d6da9e1d52b8030f6b (patch)
treeda02f4bb267128497f1ad7e3c755c8685d8005d1 /target/linux/mvebu/cortexa9
parente93626f1f47ec6c1995067c9ed3798ebd468cda3 (diff)
downloadupstream-1fa04b5d9fb1cba56a8597d6da9e1d52b8030f6b.tar.gz
upstream-1fa04b5d9fb1cba56a8597d6da9e1d52b8030f6b.tar.bz2
upstream-1fa04b5d9fb1cba56a8597d6da9e1d52b8030f6b.zip
mvebu: split base-files across subtargets
For the mvebu target in particular, there is a lot of files in base-files that are only relevant for one subtarget. Improve overview and reduce size per subtarget by moving/splitting base-files depending on the subtarget they belong to. While at it, consolidate 01_leds by using the model part of the board name as variable. Signed-off-by: Adrian Schmutzler <freifunk@adrianschmutzler.de> Acked-by: Tomasz Maciej Nowak <tomek_n@o2.pl>
Diffstat (limited to 'target/linux/mvebu/cortexa9')
-rwxr-xr-xtarget/linux/mvebu/cortexa9/base-files/etc/board.d/01_leds40
-rwxr-xr-xtarget/linux/mvebu/cortexa9/base-files/etc/board.d/02_network58
-rwxr-xr-xtarget/linux/mvebu/cortexa9/base-files/etc/init.d/bootcount16
-rw-r--r--target/linux/mvebu/cortexa9/base-files/etc/uci-defaults/03_wireless56
-rw-r--r--target/linux/mvebu/cortexa9/base-files/etc/uci-defaults/04_mambafan23
-rw-r--r--target/linux/mvebu/cortexa9/base-files/lib/preinit/06_set_iface_mac46
-rw-r--r--target/linux/mvebu/cortexa9/base-files/lib/preinit/81_linksys_syscfg37
-rw-r--r--target/linux/mvebu/cortexa9/base-files/lib/upgrade/linksys.sh98
-rwxr-xr-xtarget/linux/mvebu/cortexa9/base-files/lib/upgrade/platform.sh59
9 files changed, 433 insertions, 0 deletions
diff --git a/target/linux/mvebu/cortexa9/base-files/etc/board.d/01_leds b/target/linux/mvebu/cortexa9/base-files/etc/board.d/01_leds
new file mode 100755
index 0000000000..a7762f0080
--- /dev/null
+++ b/target/linux/mvebu/cortexa9/base-files/etc/board.d/01_leds
@@ -0,0 +1,40 @@
+#!/bin/sh
+#
+# Copyright (C) 2014-2016 OpenWrt.org
+# Copyright (C) 2016 LEDE-Project.org
+#
+
+. /lib/functions/uci-defaults.sh
+
+board_config_update
+
+board=$(board_name)
+boardname="${board##*,}"
+
+case "$board" in
+linksys,caiman|\
+linksys,cobra|\
+linksys,rango|\
+linksys,shelby)
+ ucidef_set_led_netdev "wan" "WAN" "pca963x:$boardname:white:wan" "eth1"
+ ucidef_set_led_usbport "usb1" "USB 1" "pca963x:$boardname:white:usb2" "usb1-port1"
+ ucidef_set_led_usbport "usb2" "USB 2" "pca963x:$boardname:white:usb3_1" "usb2-port1" "usb3-port1"
+ ucidef_set_led_usbport "usb2_ss" "USB 2 SS" "pca963x:$boardname:white:usb3_2" "usb3-port1"
+ ;;
+linksys,mamba)
+ ucidef_set_led_netdev "wan" "WAN" "mamba:white:wan" "eth1"
+ ucidef_set_led_usbport "usb1" "USB 1" "mamba:white:usb2" "usb1-port1"
+ ucidef_set_led_usbport "usb2" "USB 2" "mamba:white:usb3_1" "usb2-port1" "usb3-port1"
+ ucidef_set_led_usbport "usb2_ss" "USB 2 SS" "mamba:white:usb3_2" "usb3-port2"
+ ;;
+linksys,venom)
+ ucidef_set_led_netdev "wan" "WAN" "pca963x:venom:blue:wan" "eth1"
+ ucidef_set_led_usbport "usb1" "USB 1" "pca963x:venom:blue:usb2" "usb1-port1"
+ ucidef_set_led_usbport "usb2" "USB 2" "pca963x:venom:blue:usb3_1" "usb2-port1" "usb3-port1"
+ ucidef_set_led_usbport "usb2_ss" "USB 2 SS" "pca963x:venom:blue:usb3_2" "usb3-port1"
+ ;;
+esac
+
+board_config_flush
+
+exit 0
diff --git a/target/linux/mvebu/cortexa9/base-files/etc/board.d/02_network b/target/linux/mvebu/cortexa9/base-files/etc/board.d/02_network
new file mode 100755
index 0000000000..b10e1419b5
--- /dev/null
+++ b/target/linux/mvebu/cortexa9/base-files/etc/board.d/02_network
@@ -0,0 +1,58 @@
+#!/bin/sh
+#
+# Copyright (C) 2014-2016 OpenWrt.org
+# Copyright (C) 2016 LEDE-Project.org
+#
+
+. /lib/functions/uci-defaults.sh
+
+board_config_update
+
+board=$(board_name)
+
+case "$board" in
+cznic,turris-omnia)
+ ucidef_set_interface_lan "lan0 lan1 lan2 lan3 lan4"
+ ucidef_set_interface_wan "eth2"
+ ;;
+linksys,caiman|\
+linksys,cobra|\
+linksys,mamba|\
+linksys,rango|\
+linksys,shelby|\
+linksys,venom)
+ ucidef_set_interfaces_lan_wan "eth0.1" "eth1.2"
+ ucidef_add_switch "switch0" \
+ "0:lan:4" "1:lan:3" "2:lan:2" "3:lan:1" "5@eth0" "4:wan" "6@eth1"
+ ;;
+marvell,a385-db-ap)
+ ucidef_set_interfaces_lan_wan "eth0 eth1" "eth2"
+ ;;
+marvell,axp-gp)
+ ucidef_set_interface_lan "eth0 eth1 eth2 eth3"
+ ;;
+solidrun,clearfog-a1|\
+solidrun,clearfog-pro-a1)
+ # eth0 is standalone ethernet
+ # eth1 is switch
+ # eth2 is SFP
+ ucidef_set_interfaces_lan_wan "eth1" "eth0 eth2"
+
+ # switch port 5 is connected to eth1
+ ucidef_add_switch "switch0" \
+ "0:lan:5" "1:lan:4" "2:lan:3" "3:lan:2" "4:lan:1" "5u@eth1" "6:lan:6"
+ ;;
+solidrun,clearfog-base-a1)
+ # eth0 is standalone ethernet
+ # eth1 is standalone ethernet
+ # eth2 is SFP
+ ucidef_set_interfaces_lan_wan "eth1" "eth0 eth2"
+ ;;
+*)
+ ucidef_set_interface_lan "eth0"
+ ;;
+esac
+
+board_config_flush
+
+exit 0
diff --git a/target/linux/mvebu/cortexa9/base-files/etc/init.d/bootcount b/target/linux/mvebu/cortexa9/base-files/etc/init.d/bootcount
new file mode 100755
index 0000000000..dd2266bdc8
--- /dev/null
+++ b/target/linux/mvebu/cortexa9/base-files/etc/init.d/bootcount
@@ -0,0 +1,16 @@
+#!/bin/sh /etc/rc.common
+
+START=99
+
+boot() {
+ case $(board_name) in
+ linksys,caiman |\
+ linksys,cobra |\
+ linksys,mamba |\
+ linksys,rango |\
+ linksys,shelby |\
+ linksys,venom)
+ mtd resetbc s_env || true
+ ;;
+ esac
+}
diff --git a/target/linux/mvebu/cortexa9/base-files/etc/uci-defaults/03_wireless b/target/linux/mvebu/cortexa9/base-files/etc/uci-defaults/03_wireless
new file mode 100644
index 0000000000..3c345ff148
--- /dev/null
+++ b/target/linux/mvebu/cortexa9/base-files/etc/uci-defaults/03_wireless
@@ -0,0 +1,56 @@
+#!/bin/sh
+#
+# Copyright (C) 2015 OpenWrt.org
+#
+
+[ ! -e /etc/config/wireless ] && exit 0
+
+. /lib/functions.sh
+. /lib/functions/system.sh
+
+board=$(board_name)
+
+case "$board" in
+linksys,caiman|linksys,cobra|linksys,mamba|linksys,shelby|linksys,venom)
+ SKU=$(strings /dev/mtd3|sed -ne 's/^cert_region=//p')
+ WIFIMAC2G=$(macaddr_add $(cat /sys/class/net/eth0/address) +1)
+ WIFIMAC5G=$(macaddr_add $WIFIMAC2G +1)
+ case "$SKU" in
+ AP)
+ REGD=CN
+ ;;
+ AU)
+ REGD=AU
+ ;;
+ CA)
+ REGD=CA
+ ;;
+ EU)
+ REGD=DE
+ ;;
+ US)
+ REGD=US
+ ;;
+ esac
+
+ case "$board" in
+ linksys,mamba)
+ WIFIMAC0=$WIFIMAC2G
+ WIFIMAC1=$WIFIMAC5G
+ ;;
+ *)
+ WIFIMAC0=$WIFIMAC5G
+ WIFIMAC1=$WIFIMAC2G
+ ;;
+ esac
+
+ uci get wireless.radio0.country || uci set wireless.radio0.country=$REGD
+ uci get wireless.@wifi-iface[0].macaddr || uci set wireless.@wifi-iface[0].macaddr=$WIFIMAC0
+ uci get wireless.radio1.country || uci set wireless.radio1.country=$REGD
+ uci get wireless.@wifi-iface[1].macaddr || uci set wireless.@wifi-iface[1].macaddr=$WIFIMAC1
+ ;;
+esac
+
+uci commit wireless
+
+exit 0
diff --git a/target/linux/mvebu/cortexa9/base-files/etc/uci-defaults/04_mambafan b/target/linux/mvebu/cortexa9/base-files/etc/uci-defaults/04_mambafan
new file mode 100644
index 0000000000..ec25aedad6
--- /dev/null
+++ b/target/linux/mvebu/cortexa9/base-files/etc/uci-defaults/04_mambafan
@@ -0,0 +1,23 @@
+#!/bin/sh
+#
+# Copyright (C) 2017 LEDE-Project.org
+#
+
+. /lib/functions.sh
+
+board=$(board_name)
+
+case "$board" in
+linksys,mamba)
+ # Set fan script execution in crontab
+ grep -s -q fan_ctrl.sh /etc/crontabs/root && exit 0
+
+ echo "# mamba fan script runs every 5 minutes" >> /etc/crontabs/root
+ echo "*/5 * * * * /sbin/fan_ctrl.sh" >> /etc/crontabs/root
+
+ # Execute one time after initial flash (instead of waiting 5 min for cron)
+ /sbin/fan_ctrl.sh
+ ;;
+esac
+
+exit 0
diff --git a/target/linux/mvebu/cortexa9/base-files/lib/preinit/06_set_iface_mac b/target/linux/mvebu/cortexa9/base-files/lib/preinit/06_set_iface_mac
new file mode 100644
index 0000000000..fd41836c8d
--- /dev/null
+++ b/target/linux/mvebu/cortexa9/base-files/lib/preinit/06_set_iface_mac
@@ -0,0 +1,46 @@
+#
+# Copyright (C) 2014-2015 OpenWrt.org
+# Copyright (C) 2016 LEDE-Project.org
+#
+
+preinit_set_mac_address() {
+ local mac
+
+ . /lib/functions.sh
+
+ case $(board_name) in
+ linksys,caiman|linksys,cobra|linksys,rango|linksys,shelby|linksys,venom)
+ # rename interfaces back to the way they were with 4.4
+ case "$(readlink /sys/class/net/eth0)" in
+ *f1070000*)
+ ip link set eth0 name tmp0
+ ip link set eth1 name eth0
+ ip link set tmp0 name eth1
+ ;;
+ esac
+
+ mac=$(mtd_get_mac_ascii devinfo hw_mac_addr)
+ mac_wan=$(macaddr_setbit_la "$mac")
+ ip link set dev eth0 address $mac 2>/dev/null
+ ip link set dev eth1 address $mac_wan 2>/dev/null
+ ;;
+ linksys,mamba)
+ mac=$(mtd_get_mac_ascii devinfo hw_mac_addr)
+ ip link set dev eth0 address $mac 2>/dev/null
+ ip link set dev eth1 address $mac 2>/dev/null
+ ;;
+ marvell,a385-db-ap|solidrun,clearfog*a1)
+ # rename interfaces back to the way they were with 4.4
+ case "$(readlink /sys/class/net/eth0)" in
+ *f1070000*)
+ ip link set eth0 name tmp0
+ ip link set eth1 name eth0
+ ip link set eth2 name eth1
+ ip link set tmp0 name eth2
+ ;;
+ esac
+ ;;
+ esac
+}
+
+boot_hook_add preinit_main preinit_set_mac_address
diff --git a/target/linux/mvebu/cortexa9/base-files/lib/preinit/81_linksys_syscfg b/target/linux/mvebu/cortexa9/base-files/lib/preinit/81_linksys_syscfg
new file mode 100644
index 0000000000..83448e5ace
--- /dev/null
+++ b/target/linux/mvebu/cortexa9/base-files/lib/preinit/81_linksys_syscfg
@@ -0,0 +1,37 @@
+#
+# Copyright (C) 2014-2016 OpenWrt.org
+# Copyright (C) 2016 LEDE-Project.org
+#
+
+preinit_mount_syscfg() {
+ . /lib/functions.sh
+ . /lib/upgrade/common.sh
+
+ case $(board_name) in
+ linksys,caiman|linksys,cobra|linksys,mamba|linksys,rango|linksys,shelby|linksys,venom)
+ needs_recovery=0
+ syscfg_part=$(grep syscfg /proc/mtd |cut -c4)
+ ubiattach -m $syscfg_part || needs_recovery=1
+ if [ $needs_recovery -eq 1 ]
+ then
+ echo "ubifs syscfg partition is damaged, reformatting"
+ ubidetach -m $syscfg_part
+ ubiformat -y -O 2048 -q /dev/mtd$syscfg_part
+ ubiattach -m $syscfg_part
+ ubimkvol /dev/ubi1 -n 0 -N syscfg -t dynamic --maxavsize
+ fi
+ mkdir /tmp/syscfg
+ mount -t ubifs ubi1:syscfg /tmp/syscfg
+ [ -f "/tmp/syscfg/$BACKUP_FILE" ] && {
+ echo "- config restore -"
+ cd /
+ mv "/tmp/syscfg/$BACKUP_FILE" /tmp
+ tar xzf "/tmp/$BACKUP_FILE"
+ rm -f "/tmp/$BACKUP_FILE"
+ sync
+ }
+ ;;
+ esac
+}
+
+boot_hook_add preinit_main preinit_mount_syscfg
diff --git a/target/linux/mvebu/cortexa9/base-files/lib/upgrade/linksys.sh b/target/linux/mvebu/cortexa9/base-files/lib/upgrade/linksys.sh
new file mode 100644
index 0000000000..6ccfdd0768
--- /dev/null
+++ b/target/linux/mvebu/cortexa9/base-files/lib/upgrade/linksys.sh
@@ -0,0 +1,98 @@
+#
+# Copyright (C) 2014-2015 OpenWrt.org
+#
+
+linksys_get_target_firmware() {
+
+ local cur_boot_part mtd_ubi0
+
+ cur_boot_part=$(/usr/sbin/fw_printenv -n boot_part)
+ if [ -z "${cur_boot_part}" ] ; then
+ mtd_ubi0=$(cat /sys/devices/virtual/ubi/ubi0/mtd_num)
+ case $(egrep ^mtd${mtd_ubi0}: /proc/mtd | cut -d '"' -f 2) in
+ kernel1|rootfs1)
+ cur_boot_part=1
+ ;;
+ kernel2|rootfs2)
+ cur_boot_part=2
+ ;;
+ esac
+ >&2 printf "Current boot_part='%s' selected from ubi0/mtd_num='%s'" \
+ "${cur_boot_part}" "${mtd_ubi0}"
+ fi
+
+ case $cur_boot_part in
+ 1)
+ fw_setenv -s - <<-EOF
+ boot_part 2
+ bootcmd "run altnandboot"
+ EOF
+ printf "kernel2"
+ return
+ ;;
+ 2)
+ fw_setenv -s - <<-EOF
+ boot_part 1
+ bootcmd "run nandboot"
+ EOF
+ printf "kernel1"
+ return
+ ;;
+ *)
+ return
+ ;;
+ esac
+}
+
+linksys_get_root_magic() {
+ (get_image "$@" | dd skip=786432 bs=4 count=1 | hexdump -v -n 4 -e '1/1 "%02x"') 2>/dev/null
+}
+
+platform_do_upgrade_linksys() {
+ local magic_long="$(get_magic_long "$1")"
+
+ mkdir -p /var/lock
+ local part_label="$(linksys_get_target_firmware)"
+ touch /var/lock/fw_printenv.lock
+
+ if [ ! -n "$part_label" ]
+ then
+ echo "cannot find target partition"
+ exit 1
+ fi
+
+ local target_mtd=$(find_mtd_part $part_label)
+
+ [ "$magic_long" = "73797375" ] && {
+ CI_KERNPART="$part_label"
+ if [ "$part_label" = "kernel1" ]
+ then
+ CI_UBIPART="rootfs1"
+ else
+ CI_UBIPART="rootfs2"
+ fi
+
+ nand_upgrade_tar "$1"
+ }
+ [ "$magic_long" = "27051956" -o "$magic_long" = "0000a0e1" ] && {
+ # check firmwares' rootfs types
+ local target_mtd=$(find_mtd_part $part_label)
+ local oldroot="$(linksys_get_root_magic $target_mtd)"
+ local newroot="$(linksys_get_root_magic "$1")"
+
+ if [ "$newroot" = "55424923" -a "$oldroot" = "55424923" ]
+ # we're upgrading from a firmware with UBI to one with UBI
+ then
+ # erase everything to be safe
+ mtd erase $part_label
+ get_image "$1" | mtd -n write - $part_label
+ else
+ get_image "$1" | mtd write - $part_label
+ fi
+ }
+}
+
+platform_copy_config_linksys() {
+ cp -f "$UPGRADE_BACKUP" "/tmp/syscfg/$BACKUP_FILE"
+ sync
+}
diff --git a/target/linux/mvebu/cortexa9/base-files/lib/upgrade/platform.sh b/target/linux/mvebu/cortexa9/base-files/lib/upgrade/platform.sh
new file mode 100755
index 0000000000..8baed969a3
--- /dev/null
+++ b/target/linux/mvebu/cortexa9/base-files/lib/upgrade/platform.sh
@@ -0,0 +1,59 @@
+#
+# Copyright (C) 2014-2016 OpenWrt.org
+# Copyright (C) 2016 LEDE-Project.org
+#
+
+RAMFS_COPY_BIN='fw_printenv fw_setenv'
+RAMFS_COPY_DATA='/etc/fw_env.config /var/lock/fw_printenv.lock'
+REQUIRE_IMAGE_METADATA=1
+
+platform_check_image() {
+ case "$(board_name)" in
+ cznic,turris-omnia|\
+ solidrun,clearfog-base-a1|\
+ solidrun,clearfog-pro-a1)
+ platform_check_image_sdcard "$1"
+ ;;
+ *)
+ return 0
+ ;;
+ esac
+}
+
+platform_do_upgrade() {
+ case "$(board_name)" in
+ cznic,turris-omnia|\
+ solidrun,clearfog-base-a1|\
+ solidrun,clearfog-pro-a1)
+ platform_do_upgrade_sdcard "$1"
+ ;;
+ linksys,caiman|\
+ linksys,cobra|\
+ linksys,mamba|\
+ linksys,rango|\
+ linksys,shelby|\
+ linksys,venom)
+ platform_do_upgrade_linksys "$1"
+ ;;
+ *)
+ default_do_upgrade "$1"
+ ;;
+ esac
+}
+platform_copy_config() {
+ case "$(board_name)" in
+ cznic,turris-omnia|\
+ solidrun,clearfog-base-a1|\
+ solidrun,clearfog-pro-a1)
+ platform_copy_config_sdcard
+ ;;
+ linksys,caiman|\
+ linksys,cobra|\
+ linksys,mamba|\
+ linksys,rango|\
+ linksys,shelby|\
+ linksys,venom)
+ platform_copy_config_linksys
+ ;;
+ esac
+}